#ifndef SCREENLOCKINTERFACE_H
#define SCREENLOCKINTERFACE_H

#include "../../universalinterface.h"
#include <ukui-service-interface/serviceobject.h>
#include <QtDBus>

class ScreenlockInterface : public UKUI::ServiceObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.ukui.ukcc.session.Screenlock")
    Q_PROPERTY(bool showOnLogin READ getShowOnLogin)
    Q_PROPERTY(QString wallpaper READ getWallpaper)
    Q_PROPERTY(QStringList previewWallpapers READ getPreviewWallpapers)
    Q_PROPERTY(QStringList sourceWallpapers READ getSourceWallpapers)

public:
    ScreenlockInterface();
    ~ScreenlockInterface();
    bool getShowOnLogin();
    QString getWallpaper();
    QStringList getPreviewWallpapers();
    QStringList getSourceWallpapers();

public Q_SLOTS:
    void setShowOnLogin(bool b);
    void setWallpaper(QString f);
    void resetDefault();

private:
    QString copyLoginFile(QString fileName);

private:
    QStringList previewWallpaperList;
    QStringList sourceWallpaperList;
    QString     mUKCConfig     = "";
    QSettings   *lockSetting   = nullptr;
    QGSettings  *lockGSettings = nullptr;

Q_SIGNALS:
    void changed(QString key);
};

#endif // SCREENLOCKINTERFACE_H
